//
//  ConnectViewController.swift
//  lockStarsApp
//
//  Created by Richard Fasani on 3/22/16.
//  Copyright © 2016 Lock Stars. All rights reserved.
//

import UIKit

class ConnectViewController: UIViewController {

    @IBOutlet weak var web: UIWebView!
    
    override func viewDidLoad() {
        super.viewDidLoad()

        // Do any additional setup after loading the view.
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    
    @IBAction func cancel(sender: AnyObject) {
        dismissViewControllerAnimated(true, completion: nil)
    }

    @IBAction func connect(sender: AnyObject) {
        if (checkConnectionSettings()) {
            let SSID = NSUserDefaults.standardUserDefaults().valueForKey("wifiSSID") as! String
            let password = NSUserDefaults.standardUserDefaults().valueForKey("wifiPassword") as! String
            let serverAddress = NSUserDefaults.standardUserDefaults().valueForKey("wifiServerAddress") as! String
        
            let urlString = "http://192.168.4.1/" + SSID + "/" + password + "/" + serverAddress
            print(urlString)
            let requestURL = NSURL(string: urlString)
            let request = NSURLRequest(URL: requestURL!)
            web.loadRequest(request)
        }
        else {
            settingsMissingDialog()
        }
    }
    
    func checkConnectionSettings() -> Bool {
        if (NSUserDefaults.standardUserDefaults().valueForKey("wifiSSID") == nil) {
            return false
        }
        else if (NSUserDefaults.standardUserDefaults().valueForKey("wifiPassword") == nil) {
            return false
        }
        else if (NSUserDefaults.standardUserDefaults().valueForKey("wifiServerAddress") == nil) {
            return false
        }
        else {
            return true
        }
    }
    
    func settingsMissingDialog() {
        let dialog = UIAlertController(title: "Error: Home WiFi Info", message: "Home WiFi information is missing in user settings. Please update your settings.", preferredStyle: UIAlertControllerStyle.Alert)
        dialog.addAction(UIAlertAction(title: "Go to Settings", style: UIAlertActionStyle.Default, handler:{
            (UIAlertAction) -> Void in
            let settingsUrl = NSURL(string: UIApplicationOpenSettingsURLString)
            if let url = settingsUrl {
                UIApplication.sharedApplication().openURL(url)
            }
        }))
        dialog.addAction(UIAlertAction(title: "Close", style: UIAlertActionStyle.Cancel, handler: nil))
        presentViewController(dialog, animated: true, completion: nil)
    }

}
